package com.wechi.adweb.bridge.google.analytics.dto.report.row;

import static com.wechi.adweb.bridge.google.analytics.dto.report.ReportConstant.*;

import com.google.analytics.data.v1beta.Row;
import com.wechi.adweb.bridge.google.analytics.dto.report.GAReportRequestDTO;

import lombok.Builder;
import lombok.Data;

import java.util.List;

/**
 * @author wfansh
 */
@Data
@Builder
public class CountryChartData implements GAReportDataDTO {
    private String country;
    private int num;

    public static List<CountryChartData> fromReportRows(
            List<Row> reportRows, GAReportRequestDTO reportRequest) {
        int indexCountry = reportRequest.getDimensions().indexOf(DIMENSION_COUNTRY);

        return reportRows.stream()
                .map(
                        row ->
                                CountryChartData.builder()
                                        .country(row.getDimensionValues(indexCountry).getValue())
                                        // The first metric value.
                                        .num(Integer.parseInt(row.getMetricValues(0).getValue()))
                                        .build())
                .toList();
    }
}
